<?php
namespace Teknisa\PLA\Modules\Parametros\Controllers;

use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Response\Error;
use Teknisa\GER\Services\CrudService;
use Doctrine\DBAL\Connection;
use Exception;
use Zeedhi\Framework\DB\StoredProcedure\Param;
use Zeedhi\Framework\DB\StoredProcedure\StoredProcedure;

class Ger04000NutrientesPorProduto extends \Teknisa\GER\Controllers\TeknisaCrud{

	protected $connection;
	protected $util;
	protected $environment;
	protected $crudService;
	protected $parameterBag;
	protected $nrlista;

	public function __construct($crudService, $parameterBag, $connection, $util ,$environment) {
        $this->connection    = $connection;
        $this->crudService   = $crudService;
        $this->parameterBag  = $parameterBag;
        $this->util          = $util;
        $this->environment   = $environment;
    }
    
    public function excluirNutriente($request, $response) {
        try {
            $row = $request->getRow();
            $sql = "UPDATE LOGOPERA
                    SET CDORESPOPER = :CDRESPOPER,
                        NMRESPOPER = :NMRESPOPER,
                        DSRDMUSUOPER = '',
                        DSNMUSUOPER = ''
                    WHERE TRUNC(DTOPERACAO) = :DATAATUAL 
                    AND CDPESQITEM = :CDPRODUTO 
                    AND DSOPERACAO LIKE 'Produto: '|| :CDPRODUTO ||' Cod.Nutriente: '|| :CDNUTRIENTE ||'%'
                    AND NMTABELA = 'NUTRPROD'
                    AND IDTIPOOPER = '3'
                    AND NMRESPOPER = 'VIA BD'";
            $stmt = $this->connection->prepare($sql);
            $stmt->execute(
                array(
                    "CDRESPOPER"  => $this->environment->getCdOperador(),
                    "NMRESPOPER"  => $row['NMOPERADOR'],
                    "DATAATUAL"   => $row['DATA'],
                    "CDPRODUTO"   => $row['CDPRODUTO'],
                    "CDNUTRIENTE" => $row['CDNUTRIENTE']
                )
            );
        }
	    catch (\Exception $e){
            $response->setError(new Error("Erro ao excluir!". $e->getMessage(), 500));
        }
    }
    
    public function exportaNutrientesProcedure ($request, $response) {
        try {
            $row = $request->getRow();
        
            $this->nrlista = $this->util->insertLista($row['CDPRODSELECIONADOS']);
            $row['NRLISTA'] = $this->nrlista;
            
            $procedure = new StoredProcedure($this->connection, 'EXPORTA_NUTRIENTES');
            $procedure->addParam(new Param('P_CDPRODORIG',         Param::PARAM_INPUT, $row['PRODUTO']));
            $procedure->addParam(new Param('P_LISTANUTR',          Param::PARAM_INPUT, $row['CDNUTRSELECIONADOS']));
            $procedure->addParam(new Param('P_LISTAPROD',          Param::PARAM_INPUT, $row['NRLISTA']));
            $procedure->addParam(new Param('P_OPERACAO',           Param::PARAM_INPUT, $row['OPERACAO']));      
    
            $procedure->execute();
            
        } catch (\Exception $e) {
            $response->setError(new DTO\Response\Error($e->getMessage(), $e->getCode(), $e->getTraceAsString()));
        } finally {
            $this->util->deleteLista($this->nrlista);
        }
    }
}